
using LinearAlgebra, StandaloneIpopt

if !(@isdefined h)
  const _g = vec(readdlm("tmp_g.csv", ','))
  const _h = Symmetric(readdlm("tmp_h.csv", ','))
end

struct AugmentedLocalQP
  g::Vector{Float64}
  B::Symmetric{Float64, Matrix{Float64}}
end

(aqp::AugmentedLocalQP)(x) = dot(aqp.g, x) + dot(x, aqp.B, x)/2

size_constraint(store, x) = (store[1] = dot(x,x); nothing)

function raw_tr_qp(g, B, delta)
  qp = AugmentedLocalQP(g, B)
  con_lower = [-1.0]
  con_upper = [delta^2]
  cons = StandaloneIpopt.Constraints(1, size_constraint, [0.0], [delta^2])
  ini  = zeros(3)
  ipopt_optimize(qp, ini, cons; max_iter=1000)
end

