
struct AutoFwdConDerivs
  con_buf::Vector{Float64}
  jac_buf::Matrix{Float64}
end

function AutoFwdConDerivs(arglen::Int64, ncon::Int64) 
  cb = zeros(ncon)
  jb = zeros(ncon, arglen)
  AutoFwdConDerivs(cb, jb)
end

function _con_jacobian(store, cons::Constraints{F}, 
                       conderivs::AutoFwdConDerivs, p) where{F}
  cbuf = conderivs.con_buf
  jbuf = conderivs.jac_buf
  ForwardDiff.jacobian!(jbuf, cons.fun, cbuf, p)
  store .= vec(permutedims(jbuf))
end

