
# A very simple test to check the zero finder. As an added bonus, we add an
# extra keyword because the problem is quadratic:

let dummy = 1

  M = Symmetric([exp(-abs(x-y)) for x in 1:10, y in 1:10])
  c = [cos(x) for x in 1:10]
  obj(v) = dot(v, M, v) + dot(v, c)
  objg(buf, v) = ForwardDiff.gradient!(buf, obj, v)

  # Fit the objective normally for comparison:
  res_opt = ipopt_optimize(obj, normalize(ones(length(c))), 
                           print_level=0, hessian_constant="yes")

  @testset "nlsolver" begin
    res_nl = ipopt_nlsolve(objg, normalize(ones(length(c))), print_level=0)
    @test res_opt.minimizer ≈ res_nl.minimizer
  end

end
